// cliDoc.cpp : implementation of the CGamecliDoc class
//

#include "stdafx.h"
#include "gamecli.h"
#include "msg.h"
#include "cliDoc.h"
#include "clisock.h"
#include "setupdlg.h"
#include "cliview.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGamecliDoc

IMPLEMENT_DYNCREATE(CGamecliDoc, CDocument)

BEGIN_MESSAGE_MAP(CGamecliDoc, CDocument)
	//{{AFX_MSG_MAP(CGamecliDoc)
	ON_COMMAND(ID_FUNC_CONNECT, OnFuncConnect)
	ON_COMMAND(ID_FUNC_CLOSE, OnFuncClose)
	ON_COMMAND(ID_FUNC_SEND, OnFuncSend)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGamecliDoc construction/destruction

CGamecliDoc::CGamecliDoc()
{
//	m_bAutoChat = FALSE;
	m_pSocket = NULL;
	m_pFile = NULL;
	m_pArchiveIn = NULL;
	m_pArchiveOut = NULL;
	// TODO: add one-time construction code here

}

CGamecliDoc::~CGamecliDoc()
{
}
BOOL CGamecliDoc::ConnectSocket(LPCTSTR lpszHandle, LPCTSTR lpszAddress, UINT nPort)
{


	m_pSocket = new CClientSocket(this);

	if (!m_pSocket->Create())
	{
		delete m_pSocket;
		m_pSocket = NULL;
		AfxMessageBox("IDS_CREATEFAILED");
		return FALSE;
	}

	if (!m_pSocket->Connect(lpszAddress, nPort ))
		return false;

	m_username = lpszHandle;
	m_pFile = new CSocketFile(m_pSocket);
	m_pArchiveIn = new CArchive(m_pFile,CArchive::load);
	m_pArchiveOut = new CArchive(m_pFile,CArchive::store);

	CString strTemp = GetIpAddress() ;
	SendMsg(COMEIN,strTemp);

	return TRUE;
}
BOOL CGamecliDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;
/*
#ifdef _WIN32
#ifndef _UNICODE
	if (AfxGetApp()->m_lpCmdLine[0] != '\0')
	{
		TCHAR strHandle[128];
		TCHAR strServer[128];
		int nChannel;
		nChannel = 800;
//		istrstream(AfxGetApp()->m_lpCmdLine) >> strHandle >> strServer >> nChannel;
		return ConnectSocket(strHandle, strServer, nChannel);
	}
	else
#endif
#endif
*/
	{
		CSetupDlg Dialog;
		Dialog.m_serAddress = "shijun";
		Dialog.m_UserName = "shi";
		Dialog.m_socket = 800;
		while(TRUE)
		{
			if (IDOK != Dialog.DoModal())
				return FALSE;

			if (ConnectSocket(Dialog.m_UserName, Dialog.m_serAddress , Dialog.m_socket ))
				return TRUE;

			if (AfxMessageBox("޷ӵ,Ƿ?",MB_YESNO) == IDNO)
				return FALSE;
		}
	}


	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)
	return TRUE;

}

void CGamecliDoc::SendMsg(ACTION msgAction , CString& strText)
{
	if (m_pArchiveOut != NULL)
	{
		CMsg msg;

		msg.m_bAction = msgAction;
		msg.m_strText =  m_username + _T(": ") + strText;
		TRY
		{
			msg.Serialize(*m_pArchiveOut);
			m_pArchiveOut->Flush();
		}
		CATCH(CFileException, e)
		{
			m_pArchiveOut->Abort();
			delete m_pArchiveOut;
			m_pArchiveOut = NULL;
		}
		END_CATCH
	}
}


void CGamecliDoc::ProcessPendingRead()
{
	do
	{
		ReceiveMsg();
		if (m_pSocket == NULL)
			return;
	}
	while(!m_pArchiveIn->IsBufferEmpty());
}

void CGamecliDoc::ReceiveMsg()
{
	CMsg msg;

	TRY
	{
		msg.Serialize(*m_pArchiveIn);
		DisplayMsg(&msg);
		
	}
	CATCH(CFileException, e)
	{
/*
		m_pArchiveOut->Abort();

		CString strTemp;
		if (strTemp.LoadString(IDS_SERVERRESET))
			DisplayMsg(strTemp);
		if (strTemp.LoadString(IDS_CONNECTIONCLOSED))
			DisplayMsg(strTemp);
*/

	}
	END_CATCH

	if (msg.m_bAction == REFUSE)
	{
		delete m_pArchiveIn;
		m_pArchiveIn = NULL;
		delete m_pArchiveOut;
		m_pArchiveOut = NULL;
		delete m_pFile;
		m_pFile = NULL;
		delete m_pSocket;
		m_pSocket = NULL;
	}

}
CString CGamecliDoc::GetIpAddress()
{
      WORD    wversionrequested;
      WSAData  wsadata;
      char name[255];
      CString ip;
      hostent *hostinfo;
      wversionrequested = MAKEWORD( 2, 0 );

      if ( WSAStartup( wversionrequested, &wsadata ) == 0 )
      {

            if( gethostname ( name, sizeof(name)) == 0)
            {
                  if((hostinfo = gethostbyname(name)) != NULL)
                  {
                        ip = inet_ntoa (*(struct in_addr *)*hostinfo->h_addr_list);
	
                  }
            }
            
            WSACleanup( );
      } 
	return ip;
}

void CGamecliDoc::DisplayMsg(CMsg * pMsg)
{
	for(POSITION pos=GetFirstViewPosition();pos!=NULL;)
	{
		CView* pView = GetNextView(pos);
		CGamecliView* pGamecliView = DYNAMIC_DOWNCAST(CGamecliView, pView);
		if (pGamecliView != NULL)
			pGamecliView->Message(pMsg);
	}

}

/////////////////////////////////////////////////////////////////////////////
// CGamecliDoc serialization

void CGamecliDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CGamecliDoc diagnostics

#ifdef _DEBUG
void CGamecliDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CGamecliDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CGamecliDoc commands

void CGamecliDoc::OnFuncConnect() 
{

}

void CGamecliDoc::OnFuncClose() 
{
	// TODO: Add your command handler code here
	
}

void CGamecliDoc::OnFuncSend() 
{
	// TODO: Add your command handler code here
	
}

void CGamecliDoc::OnCloseDocument() 
{
	// TODO: Add your specialized code here and/or call the base class
	CDocument::OnCloseDocument();
}

void CGamecliDoc::DeleteContents() 
{

	if ((m_pSocket != NULL) && (m_pFile != NULL) && (m_pArchiveOut != NULL))
	{
		CString strTemp = _T("");
		SendMsg(GOOUT,strTemp);
	}

	delete m_pArchiveOut;
	m_pArchiveOut = NULL;
	delete m_pArchiveIn;
	m_pArchiveIn = NULL;
	delete m_pFile;
	m_pFile = NULL;

	if (m_pSocket != NULL)
	{
		BYTE Buffer[50];
		m_pSocket->ShutDown();

		while(m_pSocket->Receive(Buffer,50) > 0);
	}

	delete m_pSocket;
	m_pSocket = NULL;
/*
	for(POSITION pos=GetFirstViewPosition();pos!=NULL;)
	{
		CView* pView = GetNextView(pos);

		if (pView->IsKindOf(RUNTIME_CLASS(CChatView)))
		{
			CChatView* pChatView = (CChatView*)pView;
			pChatView->GetEditCtrl().SetWindowText(_T(""));
		}
	}
*/
	CDocument::DeleteContents();
}
