

#include "stdafx.h"
#include "room.h"
#include "gamesvr.h"
#include <afxsock.h>
#include "lstnsock.h"
#include "clntsock.h"
#include "svrDoc.h"
#include "setupDlg.h"
#include "msg.h"


#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMsg
#define DPORT   800

IMPLEMENT_DYNCREATE(CRoom, CObject)

/////////////////////////////////////////////////////////////////////////////
// CMsg construction/destruction

CRoom::CRoom()
{
	m_pListen = NULL;
	m_msgList.RemoveAll() ;
	m_memberList.RemoveAll();
	m_timeStarted = CTime::GetCurrentTime ();
	
}

CRoom::~CRoom()
{
	delete m_pListen;
}

/////////////////////////////////////////////////////////////////////////////
// CMsg Operations

/////////////////////////////////////////////////////////////////////////////
// CMsg serialization
BOOL CRoom::BeginListen ()
{
	CsetupDlg SetupDlg;
	SetupDlg.m_socket = 800 ;
	if (IDOK == SetupDlg.DoModal() )
	{
		m_pListen = new CListeningSocket(this);
		if (m_pListen->Create(SetupDlg.m_socket ))
		{
			if (m_pListen->Listen())
				return true;
		}
	}
	return false;
}


void CRoom::StopListening( void )
{

}


void CRoom::ProcessPendingAccept()
{
	CClientSocket* pSocket = new CClientSocket(this);

	if (m_pListen->Accept(*pSocket))
	{
		pSocket->Init();
		m_memberList.AddTail(pSocket);
	}
	else
		delete pSocket;
}





void CRoom::ProcessPendingRead(CClientSocket* pSocket)
{
	do
	{
		CMsg* pMsg = ReadMsg(pSocket);

			ProcessMsg(pSocket,pMsg);		//ִϢ
			if ( pSocket )			//пܸóԱɾ
				break;
	}
	while (!pSocket->m_pArchiveIn->IsBufferEmpty());


}
void CRoom::ProcessMsg(CClientSocket * pSocket , CMsg * pMsg)
{//ÿһ Ϣ
	switch(pMsg->m_bAction )
	{
		case 	NOACTION:		//Ϊ ûж
			break;
		case	CLOSE:			//Ϊ ر
			break;
		case	ISTALKING:		//Ϊ ˵
			Message(pMsg->m_strText);
			m_msgList.AddTail(pMsg->m_strText);
			UpdateClientsTalkingWords();
			break;
		case	DOACTION:		//Ϊ 
			break;
		case	GOOUT:			//Ϊ ˳˷
			{
			CloseSocket(pSocket,pSocket->UserName + "뿪",GOOUT);
			break;
			}
		case	COMEIN:			//Ϊ 뷿
			{
			CString strTemp =pMsg->m_strText ;
			pSocket->UserName = strTemp.Left(strTemp.Find(_T(":")));
			bool bHave = false ;
			//ԱǷѾ˸UserName
			for(POSITION pos = m_memberList.GetHeadPosition(); pos != NULL;)
			{
				CClientSocket* pSocket1 = (CClientSocket*)m_memberList.GetNext(pos);
				if (( pSocket1 != pSocket  ) && ( pSocket1->UserName == pSocket->UserName ))
				{
					bHave = true ;
				}
			}
			if ( bHave )
			{
				//Ѿ˸û,򽫸ûɾ
				CloseSocket(pSocket,"Բ,ûѾ!",REFUSE);
			}
			else
			{
				Message(pSocket->UserName + " ҽ뷿");
				m_msgList.AddTail(pSocket->UserName + " ҽ뷿");
//				CString strTemp = pSocket->UserName ;
//				strTemp = strTemp.Left(strTemp.Find(_T(":")));
				AddMember(pSocket->UserName );
				UpdateClientsTalkingWords();
				RefreshMembers();
			}
			break;
			}
	}
}
void CRoom::CloseSocket(CClientSocket* pSocket , LPCTSTR Message , ACTION msgAction)
{
	//ڷɾóԱ,ͻ˷һϢ
	CString strTemp = Message ;
	CMsg msg;
	msg.Init();
	msg.m_bAction = msgAction ;
	msg.m_msgList.AddTail(strTemp);
	SendMsg(pSocket,&msg);
	pSocket->Close();

	POSITION pos,temp;
	for(pos = m_memberList.GetHeadPosition(); pos != NULL;)
	{
		temp = pos;
		CClientSocket* pSock = (CClientSocket*)m_memberList.GetNext(pos);
		if (pSock == pSocket)
		{
			m_memberList.RemoveAt(temp);
			break;
		}
	}
	DeleteMember(pSocket->UserName );
	delete pSocket;
}
CMsg* CRoom::ReadMsg(CClientSocket* pSocket)
{
	static CMsg msg;
	TRY
	{
		pSocket->ReceiveMsg(&msg);
	}
	CATCH(CFileException, e)
	{
		CString strTemp;
		msg.m_bAction = GOOUT;
		pSocket->Abort();
	}
	END_CATCH

	return &msg;
}

void CRoom::UpdateClientsTalkingWords()
{
	for(POSITION pos = m_memberList.GetHeadPosition(); pos != NULL;)
	{
		CClientSocket* pSocket = (CClientSocket*)m_memberList.GetNext(pos);
		CMsg* pMsg = AssembleTalkingWordsMsg(pSocket);

		if (pMsg != NULL)
			SendMsg(pSocket, pMsg);
	}
}
void CRoom::RefreshMembers()
{
	CMsg msg;
	msg.Init() ;
	msg.m_bAction = REFRESHMEMBERS;
	POSITION pos;
	for(pos = m_memberList.GetHeadPosition(); pos != NULL;)
	{
		CClientSocket* pSocket = (CClientSocket*)m_memberList.GetNext(pos);
		msg.m_msgList.AddTail(pSocket->UserName );
	}
	for(pos = m_memberList.GetHeadPosition(); pos != NULL;)
	{
		CClientSocket* pSocket = (CClientSocket*)m_memberList.GetNext(pos);
		SendMsg(pSocket, &msg);
	}


}
CMsg* CRoom::AssembleTalkingWordsMsg(CClientSocket* pSocket)
{
	static CMsg msg;

	msg.Init();

	if (pSocket->m_msgCount >= m_msgList.GetCount())
		return NULL;

	for (POSITION pos1 = m_msgList.FindIndex(pSocket->m_msgCount); pos1 != NULL;)
	{
		CString temp = m_msgList.GetNext(pos1);
		msg.m_msgList.AddTail(temp);
	}
	pSocket->m_msgCount = m_msgList.GetCount();
	msg.m_bAction = ISTALKING;
	return &msg;
}
void CRoom::SendMsg(CClientSocket* pSocket, CMsg* pMsg)
{
	TRY
	{
		pSocket->SendMsg(pMsg);
	}
	CATCH(CFileException, e)
	{
		pSocket->Abort();

		CString strTemp;
//		if (strTemp.LoadString(IDS_SENDERROR))
//			Message(strTemp);
	}
	END_CATCH
}

void CRoom::CloseAllSocket ()
{
	
		delete m_pListen;			//
		m_pListen = NULL;

		CString temp;
		m_msgList.AddTail("Sever has closed!");

		while(!m_memberList.IsEmpty())
		{
			CClientSocket* pSocket = (CClientSocket*)m_memberList.RemoveHead();
			if (!pSocket->IsAborted())
			{
				pSocket->ShutDown();

				BYTE Buffer[50];

				while (pSocket->Receive(Buffer,50) > 0);
				DeleteMember(pSocket->UserName );
				delete pSocket;
			}
		}

		m_msgList.RemoveAll();
}

void CRoom::Serialize(CArchive& ar)
{
}
void CRoom::AddMember(LPCTSTR lpszMember)
{
	pDoc->AddMember(lpszMember);
}
void CRoom::DeleteMember(LPCTSTR UserName)
{
	pDoc->DeleteMember(UserName);
}
void CRoom::Message(LPCTSTR lpszMessage)
{
	pDoc->Message(lpszMessage);
}
/////////////////////////////////////////////////////////////////////////////
// CRoom diagnostics

#ifdef _DEBUG
void CRoom::AssertValid() const
{
	CObject::AssertValid();
}

void CRoom::Dump(CDumpContext& dc) const
{
	CObject::Dump(dc);
}
#endif //_DEBUG
